// Javascript Indent Tool : http://jsbeautifier.org/
var arrowDownImgTag = '<img src="file:///android_asset/goo/arrow-down.png" draggable="false" style="-webkit-user-select: none; border: 0px; padding: 0px; margin: -2px 0px 0px; position: absolute; right: 6px; top: 50%; width: 7px; height: 4px;">';

//===================================================================
function todaydate() {
    var today_date = new Date()
    var myyear = today_date.getYear()
    var mymonth = today_date.getMonth() + 1
    var mytoday = today_date.getDate()
    document.write(myyear + "/" + mymonth + "/" + mytoday)
}

//===================================================================
function timeoutFunc_0() {

    if (gMarkerCur != null) {
        gMarkerCur.setAnimation(null);
    }

    if (gPlaceSearchControlInput.value != null) {
        if (gPlaceSearchControlInput.value != "") {
            place_deleteMarkers();
            place_textSearch();
        }
    }
}

//function timeoutFunc_1(){			
//
//    if(gMarkerPlacePoi!=null){
//		gMarkerPlacePoi.setAnimation(null);
//	}
//}			

function markerCur_streetView_gotoSV() {

    //console.log("markerCur_streetView_gotoSV");

    gSV_panorama = map.getStreetView();
    gSV_panorama.setPosition(gMarkerCur.position);
    gSV_panorama.setPov( /** @type {google.maps.StreetViewPov} */ ({
        heading: 265,
        pitch: 0
    }));
    gSV_panorama.setVisible(true);
}

function markerCur_processSVDataCallback(data, status) {

    var content = gMarkerCurName + "<BR>";

    if (gIsMarkerReverseGeocoderOK == true) {
        content += gMarkerAddressName + "<BR>";
    }

    content += "<BR>";

    if (status == google.maps.StreetViewStatus.OK) {

        content += '<button id="mySvBtn" type="button" onclick="markerCur_streetView_gotoSV()">' + gText_BtnStreetView + '</button>';
        //content += '<button type="button">' + 'Try tttt' + '</button>';
        // <button type="button" onclick="myFunction()">Try it</button>
        content += "<BR>";
    }

    gPlaceInfowindow.setContent(content);
    gPlaceInfowindow.open(map, gMarkerCur);

    if (status == google.maps.StreetViewStatus.OK) {
        gSV_panorama = map.getStreetView();
        if (gSV_panorama.getVisible()) {
            markerCur_streetView_gotoSV();
        }
    } else {
        gSV_panorama = map.getStreetView();
        if (gSV_panorama.getVisible()) {
            gSV_panorama.setVisible(false);
        }
    }
}

function markerCur_showInfoWindow() {

    gIsMarkerReverseGeocoderOK = false;
    var geocoder = new google.maps.Geocoder();
    geocoder.geocode({
        'latLng': gMarkerCur.position
    }, function (results, status) {
        if (status == google.maps.GeocoderStatus.OK) {
            if (results[0]) {
                gIsMarkerReverseGeocoderOK = true;
                gMarkerAddressName = results[0].formatted_address;
            } else if (results[1]) {
                gIsMarkerReverseGeocoderOK = true;
                gMarkerAddressName = results[1].formatted_address;
            } else if (results[2]) {
                gIsMarkerReverseGeocoderOK = true;
                gMarkerAddressName = results[2].formatted_address;
            } else if (results[3]) {
                gIsMarkerReverseGeocoderOK = true;
                gMarkerAddressName = results[3].formatted_address;
            } else if (results[4]) {
                gIsMarkerReverseGeocoderOK = true;
                gMarkerAddressName = results[4].formatted_address;
            } else if (results[5]) {
                gIsMarkerReverseGeocoderOK = true;
                gMarkerAddressName = results[5].formatted_address;
            } else if (results[6]) {
                gIsMarkerReverseGeocoderOK = true;
                gMarkerAddressName = results[6].formatted_address;
            } else if (results[7]) {
                gIsMarkerReverseGeocoderOK = true;
                gMarkerAddressName = results[7].formatted_address;
            } else {
                //console.log("error: not result[] ok");
            }
        } else {
            //console.log("error: status = " + status);
        }

        if (gSV_serviceInited == false) {
            gSV_service = new google.maps.StreetViewService();
            gSV_serviceInited = true;
        }
        gSV_service.getPanoramaByLocation(gMarkerCur.position, 50, markerCur_processSVDataCallback);
    });
}

function modifyMarker(lat, log) {

    place_deleteMarkers();

    if (gMarkerCur != null) {
        clearTimeout(gTimeoutId_0);
        gMarkerCur.setMap(null);
        gMarkerCur = null;
    }

    var latLng = new google.maps.LatLng(lat, log);
    gLatLng = latLng;

    //var image = 'file:///android_asset/goo/gps_icon_32x16.png';
    //var image = 'file:///android_asset/goo/empty_icon_32x16.png'
    gMarkerCur = new google.maps.Marker({
        position: latLng,
        //map: map,
        animation: google.maps.Animation.DROP
        //icon: image
    });
    gMarkerCur.setMap(map);
    gMarkerCur.setAnimation(google.maps.Animation.BOUNCE);

    gTimeoutId_0 = setTimeout("timeoutFunc_0()", 2000);
    map.setCenter(latLng);
    map.panTo(latLng);

    google.maps.event.addListener(gMarkerCur, 'click', function () {

        markerCur_showInfoWindow();
    });

    if (gPlaceSearchValueTmp == "") {

        markerCur_showInfoWindow();
    } else {

        gSV_panorama = map.getStreetView();
        if (gSV_panorama.getVisible()) {
            gSV_panorama.setVisible(false);
        }
    }
}

function modifyZoomLevel(level) {

    map.setZoom(level);
}

function modifyMapTypeId(posOfSelect) {

    if (posOfSelect == 0) {
        map.setMapTypeId(google.maps.MapTypeId.ROADMAP);
    } else if (posOfSelect == 1) {
        map.setMapTypeId(google.maps.MapTypeId.SATELLITE);
    } else if (posOfSelect == 2) {
        map.setMapTypeId(google.maps.MapTypeId.TERRAIN);
    } else if (posOfSelect == 3) {
        map.setMapTypeId(google.maps.MapTypeId.HYBRID);
    }
}

function initOtherSettings() {

    // Layer Settings.
    layer_set_to_map();
}

function addChangeListener() {

    document.onmousedown = function (e) {

        var layer04CheckedInnerUI = document.getElementById("weather_degree_type")

        //console.log("document.onmousedown");
        //console.log(e.target);
        if (e.target == gLayerControlUI) {
            //console.log("e.target==gLayerControlUI");
            return;
        } else if (e.target == gLayerGroupUI) {
            //console.log("e.target==gLayerGroupUI");
            return;
        } else if (e.target == gLayer00UI) {
            //console.log("e.target==gLayer00UI");
            return;
        } else if (e.target == gLayer01UI) {
            //console.log("e.target==gLayer01UI");
            return;
        } else if (e.target == gLayer02UI) {
            //console.log("e.target==gLayer02UI");
            return;
        } else if (e.target == gLayer03UI) {
            //console.log("e.target==gLayer03UI");
            return;
        } else if (e.target == gLayer04UI) {
            //console.log("e.target==gLayer04UI");
            return;
        } else if (e.target == gLayer04TextUI) {
            //console.log("e.target==gLayer04TextUI");
            return;
        } else if (e.target == gLayer04CheckedUI) {
            //console.log("e.target==gLayer04CheckedUI");
            return;
        } else if (e.target == layer04CheckedInnerUI) {
            //console.log("e.target==layer04CheckedInnerUI");
            return;
        } else if (e.target == gLayer05UI) {
            //console.log("e.target==gLayer05UI");
            return;
        } else {
            gLayerGroupUI.style.visibility = 'hidden';
        }
    }

    //google.maps.event.addListener(map, 'click', function(event) {
    //	
    //	console.log("map clicked !!!!!!!!!!!!!!!!");
    //});

    google.maps.event.addListener(map, 'zoom_changed', function () {
        var zoomLevel = map.getZoom();

        //console.log("zoom_changed : " + zoomLevel);
        MainActivityInterface.onMapZoomLevelChanged(zoomLevel);
    });

    google.maps.event.addListener(map, 'maptypeid_changed', function () {
        var tmpMapTypeId = map.getMapTypeId();
        var iMapTypeSelect = 0;
        if (tmpMapTypeId == google.maps.MapTypeId.ROADMAP) {
            iMapTypeSelect = 0;
        } else if (tmpMapTypeId == google.maps.MapTypeId.SATELLITE) {
            iMapTypeSelect = 1;
        } else if (tmpMapTypeId == google.maps.MapTypeId.TERRAIN) {
            iMapTypeSelect = 2;
        } else if (tmpMapTypeId == google.maps.MapTypeId.HYBRID) {
            iMapTypeSelect = 3;
        }
        MainActivityInterface.onMapTypeIdChanged(iMapTypeSelect);
    });

    // Create the DIV to hold the control and
    // call the SwitchScreenControl() constructor passing
    // in this DIV.
    var switchScreenControlDiv = document.createElement('div');
    var switchScreenControl = new SwitchScreenControl(switchScreenControlDiv, map);
    switchScreenControlDiv.index = 0;
    map.controls[google.maps.ControlPosition.LEFT_BOTTOM].push(switchScreenControlDiv);

    //map.setOptions({
    //  scaleControl: true,
    //  streetViewControl: true,
    //  streetViewControlOptions: {
    //	position: google.maps.ControlPosition.LEFT_BOTTOM
    //  },
    //});

    var layerControlDiv = document.createElement('div');
    var layerControl = new LayerControl(layerControlDiv, map);
    layerControlDiv.index = 1;
    if ("undefined" != typeof map.controls[google.maps.ControlPosition.LEFT_TOP]) {
        map.controls[google.maps.ControlPosition.LEFT_TOP].push(layerControlDiv);
    } else {
        map.controls[google.maps.ControlPosition.LEFT_TOP] = new Array();
        map.controls[google.maps.ControlPosition.LEFT_TOP].push(layerControlDiv);
    }

    gPlacePoiSelControlDiv = document.createElement('div');
    var placePoiSelControl = new PlacePoiSelControl(gPlacePoiSelControlDiv, map);
    gPlacePoiSelControlDiv.index = 0;
    //map.controls[google.maps.ControlPosition.BOTTOM_CENTER].push(gPlacePoiSelControlDiv);
    //gPlacePoiSelControlDiv.style.visibility = 'hidden';

    var searchControlDiv = document.createElement('div');
    var searchControl = new SearchControl(searchControlDiv, map);
    searchControlDiv.index = 1;
    map.controls[google.maps.ControlPosition.TOP_LEFT].push(searchControlDiv);

    //document.onkeydown = function(event) {
    //
    //	console.log(event.keyCode);
    //	console.log(">>" + gPlaceSearchControlInput.value);		
    //
    //    if (event.keyCode == 13){	
    //		document.activeElement.blur();
    //	}			
    //}	

    //document.onmousedown = function(event) {
    //	
    //    if (gLayerGroupUI.style['visibility'] == 'visible') {
    //        gLayerGroupUI.style.visibility = 'hidden';
    //    }		
    //}
}
//===================================================================		

function SwitchScreenControl(controlDiv, map) {

    // Set CSS styles for the DIV containing the control
    // Setting padding to 5 px will offset the control
    // from the edge of the map
    controlDiv.style.paddingLeft = '5px';
    controlDiv.style.paddingBottom = '5px';

    // Set CSS for the control border
    var controlUI = document.createElement('div');
    controlUI.style.backgroundColor = 'white';
    controlUI.style.border = '1px solid rgba(0, 0, 0, 0.14902)';
    controlUI.style.cursor = 'pointer';
    controlUI.style.textAlign = 'center';
    controlUI.title = '';
    controlDiv.appendChild(controlUI);

    // Set CSS for the control interior
    gSwichScreen_ControlUI = document.createElement('div');
    gSwichScreen_ControlUI.style.width = '32px';
    gSwichScreen_ControlUI.style.height = '32px';
    gSwichScreen_ControlUI.innerHTML = '<img src="file:///android_asset/goo/to_full_screen_normal.png" style="border: 0px; padding: 0px; width: 32px; height: 32px;">';
    controlUI.appendChild(gSwichScreen_ControlUI);

    google.maps.event.addDomListener(controlUI, 'click', function () {

        //console.log("onMapScreenChanged");

        gView_Center = map.getCenter();
        MainActivityInterface.onMapScreenChanged();
    });
}

//===================================================================		
var autocomplete = null;

function SearchControl(controlDiv, map) {

    // Set CSS styles for the DIV containing the control
    // Setting padding to 5 px will offset the control
    // from the edge of the map
    controlDiv.style.padding = '5px';

    // Set CSS for the control border
    var controlUI = document.createElement('div');
    controlUI.style.backgroundColor = 'white';
    controlUI.style.border = '1px solid rgba(0, 0, 0, 0.14902)';
    controlUI.style.cursor = 'pointer';
    controlUI.style.textAlign = 'center';
    controlUI.title = '';
    controlDiv.appendChild(controlUI);

    var table = document.createElement('table');
    table.style.borderCollapse = "collapse"
    table.style.tableLayout = "fixed";

    var tr = document.createElement('tr');

    tr.style.margin = '0px';
    tr.style.padding = '0px';
    tr.style.backgroundColor = 'black';
    tr.style.borderCollapse = "collapse"
    tr.style.width = '186px';
    tr.style.height = '20px';

    var td1 = document.createElement('td');
    var td2 = document.createElement('td');

    td1.style.margin = '0px';
    td1.style.padding = '0px';
    td1.style.backgroundColor = 'white';
    td1.style.borderWidth = '0px';
    td1.style.width = '160px';
    td1.style.height = '26px';

    td2.style.margin = '0px';
    td2.style.padding = '0px';
    td2.style.backgroundColor = 'gray';
    td2.style.borderWidth = '0px';
    td2.style.width = '26px';
    td2.style.height = '26px';

    // Set CSS for the control interior
    gPlaceSearchControlInput = document.createElement('input');
    gPlaceSearchControlInput.style.backgroundColor = 'white';
    gPlaceSearchControlInput.setAttribute("style", "padding: 3px 5px; font-weight: 500;");
    gPlaceSearchControlInput.setAttribute("type", "text");
    gPlaceSearchControlInput.setAttribute("value", gText_PlaceSearchValue);
    gPlaceSearchValueOld = gPlaceSearchValueTmp = gText_PlaceSearchValue;
    gPlaceSearchControlInput.setAttribute("placeholder", gText_PlaceSearchPlaceholder);
    gPlaceSearchControlInput.setAttribute("onfocus", "placeSearchInputOnFocus()");
    gPlaceSearchControlInput.setAttribute("onblur", "placeSearchInputOnBlur()");
    gPlaceSearchControlInput.style.width = '160px';
    gPlaceSearchControlInput.style.height = '20px';

    // Set CSS for the control interior
    var placeSearchControlClear = document.createElement('div');
    placeSearchControlClear.style.backgroundColor = 'white';
    placeSearchControlClear.setAttribute("style", "padding: 1px; font-weight: 500;");
    placeSearchControlClear.style.textAlign = 'center';
    placeSearchControlClear.style.backgroundColor = 'white';
    placeSearchControlClear.style.borderWidth = '0px';
    placeSearchControlClear.style.width = '24px';
    placeSearchControlClear.style.height = '24px';
    placeSearchControlClear.innerHTML = '<img src="file:///android_asset/goo/eraser.png" style="border: 0px; width: 24px; height: 24px;">';

    td1.appendChild(gPlaceSearchControlInput);
    td2.appendChild(placeSearchControlClear);
    tr.appendChild(td1);
    tr.appendChild(td2);
    table.appendChild(tr)
    controlUI.appendChild(table);

    //S-EV
    google.maps.event.addDomListener(gPlaceSearchControlInput, 'keydown', function (e) {

        if (e.keyCode == 13) {

            //console.log("keydown 13");
            //console.log(gPlaceSearchControlInput.value);

            if (gIsPlaceSearchFuncAlreadyProcess == true) {} else {

                gIsPlaceSearchFuncAlreadyProcess = true;

                var isStrNotNull = false;

                if (gPlaceSearchControlInput.value != null) {
                    if (gPlaceSearchControlInput.value != "") {

                        var str = gPlaceSearchControlInput.value;
                        str = str.replace(/\s+/g, "");

                        if (str != "") {
                            isStrNotNull = true;
                        }
                    }
                }

                if (isStrNotNull == true) {
                    gPlaceSearchValueTmp = gPlaceSearchControlInput.value;
                } else {
                    gPlaceSearchValueTmp = "";
                }

                placeSearchValueChanged();
                setTimeout("placeSearchInputBlurAndUpdateValue()", 100);
            }
        }
    });

    autocomplete = new google.maps.places.Autocomplete(gPlaceSearchControlInput);
    autocomplete.bindTo('bounds', map);
    //S-EV
    google.maps.event.addListener(autocomplete, 'place_changed', function () {

        //console.log("place_changed");
        //console.log(gPlaceSearchControlInput.value);

        if (gIsPlaceSearchFuncAlreadyProcess == true) {} else {

            gIsPlaceSearchFuncAlreadyProcess = true;

            var isStrNotNull = false;

            if (gPlaceSearchControlInput.value != null) {
                if (gPlaceSearchControlInput.value != "") {

                    var str = gPlaceSearchControlInput.value;
                    str = str.replace(/\s+/g, "");

                    if (str != "") {
                        isStrNotNull = true;
                    }
                }
            }

            if (isStrNotNull == true) {
                gPlaceSearchValueTmp = gPlaceSearchControlInput.value;
            } else {
                gPlaceSearchValueTmp = "";
            }

            placeSearchValueChanged();
            setTimeout("placeSearchInputBlurAndUpdateValue()", 100);
        }
    });

    //S-EV
    google.maps.event.addDomListener(placeSearchControlClear, 'click', function () {

        //console.log("clear click");
        //console.log(gPlaceSearchControlInput.value);

        gIsPlaceSearchFuncAlreadyProcess = true;

        if (gIsPlaceSearchInputFocus == true) {
            gPlaceSearchValueTmp = "";
            placeSearchValueChanged();
            setTimeout("placeSearchInputBlurAndUpdateValue()", 100);
        } else {

            gPlaceSearchValueTmp = "";
            placeSearchValueChanged();
            setTimeout("placeSearchInputBlurAndUpdateValue()", 100);
        }

        MainActivityInterface.onToastClearSearchText();
    });


}

function placeSearchValueChanged() {

    //console.log("placeSearchValueChanged");
    //console.log("gPlaceSearchControlInput.value = " + gPlaceSearchControlInput.value);
    //console.log("gPlaceSearchValueTmp = " + gPlaceSearchValueTmp);

    gPlaceSearchControlInput.value = gPlaceSearchValueTmp;
    if (gPlaceSearchValueTmp != "") {

        place_deleteMarkers();
        place_textSearch();
    } else {

        placeSearchPlacesClose();
    }

    //e.preventDefault(); 
}

function placeSearchPlacesClose() {

    gPlaceInfowindow.close();
    place_deleteMarkers();
    //MainActivityInterface.onSettingsPlaceSearchValue("");

    map.controls[google.maps.ControlPosition.BOTTOM_CENTER].clear();
    gIsPlaceDivPushed = false;

    map.setCenter(gMarkerCur.position);
    map.panTo(gMarkerCur.position);
}

//===================================================================

function layerWeatherDigreeType() {

    gWeatherDegreeIsC = document.getElementById("weather_degree_type").checked;
    //console.log("isDegreeC=" + gWeatherDegreeIsC);

    gLayerControlUI.innerHTML = gText_LayerWeather + arrowDownImgTag;
    //gLayerGroupUI.style.visibility = 'hidden';
    gLayer_index = 4;
    layer_set_to_map();

    MainActivityInterface.onSettingsWeatherDegreeIsC(gWeatherDegreeIsC);

    if (map.getZoom() > 11) {
        map.setZoom(11);
    }
}

function LayerControl(controlDiv, map) {

    // Set CSS styles for the DIV containing the control
    // Setting padding to 5 px will offset the control
    // from the edge of the map
    //controlDiv.style.padding = '5px';
    controlDiv.style.width = '100px';
    controlDiv.style.height = '20px';
    controlDiv.style.margin = '5px';
    //controlDiv.style.left = '0px';
    //controlDiv.style.top = '0px'
    controlDiv.style.zIndex = '100';

    // Set CSS for the control border
    gLayerControlUI = document.createElement('div');
    gLayerControlUI.style.backgroundColor = 'white';
    gLayerControlUI.style.padding = '1px 6px 1px 6px';
    gLayerControlUI.style.borderBottomLeftRadius = '2px';
    gLayerControlUI.style.borderTopLeftRadius = '2px';
    gLayerControlUI.style.borderBottomRightRadius = '2px';
    gLayerControlUI.style.borderTopRightRadius = '2px';

    gLayerControlUI.style.top = '0px';
    gLayerControlUI.style.boxShadow = '0px 1px 4px -1px rgba(0, 0, 0, 0.298039)';
    gLayerControlUI.style.border = '1px solid rgba(0, 0, 0, 0.14902)';
    gLayerControlUI.style.cursor = 'pointer';
    gLayerControlUI.style.textAlign = 'left';
    gLayerControlUI.style.fontSize = "11px";
    gLayerControlUI.style.fontWeight = "500";

    gLayerControlUI.title = '';
    if (gLayer_index == 0) {
        gLayerControlUI.innerHTML = gText_LayerNormal + arrowDownImgTag;
    } else if (gLayer_index == 1) {
        gLayerControlUI.innerHTML = gText_LayerTraffic + arrowDownImgTag;
    } else if (gLayer_index == 2) {
        gLayerControlUI.innerHTML = gText_LayerTransit + arrowDownImgTag;
    } else if (gLayer_index == 3) {
        gLayerControlUI.innerHTML = gText_LayerBike + arrowDownImgTag;
    } else if (gLayer_index == 4) {
        gLayerControlUI.innerHTML = gText_LayerWeather + arrowDownImgTag;
    } else if (gLayer_index == 5) {
        gLayerControlUI.innerHTML = gText_LayerPanoramio + arrowDownImgTag;
    } else {
        gLayer_index = 0;
        gLayerControlUI.innerHTML = gText_LayerNormal + arrowDownImgTag;
    }
    gLayerGroupUI = document.createElement('div');

    gLayer00UI = document.createElement('div');
    gLayer01UI = document.createElement('div');
    gLayer02UI = document.createElement('div');
    gLayer03UI = document.createElement('div');
    gLayer04UI = document.createElement('tr');
    gLayer05UI = document.createElement('div');

    var styleXXX = "cursor: pointer; color: rgb(86, 86, 86); font-family: Roboto, Arial, sans-serif; -webkit-user-select: none; font-size: 11px; background-color: rgb(255, 255, 255); padding: 3px 5px; font-weight: 500;";
    gLayer00UI.setAttribute('style', styleXXX);
    gLayer01UI.setAttribute('style', styleXXX);
    gLayer02UI.setAttribute('style', styleXXX);
    gLayer03UI.setAttribute('style', styleXXX);
    gLayer04UI.setAttribute('style', styleXXX);
    gLayer05UI.setAttribute('style', styleXXX);

    gLayer00UI.innerHTML = gText_LayerNormal;
    gLayer01UI.innerHTML = gText_LayerTraffic;
    gLayer02UI.innerHTML = gText_LayerTransit;
    gLayer03UI.innerHTML = gText_LayerBike;

    gLayer04UI.style.margin = '0px';
    gLayer04UI.style.padding = '0px';
    gLayer04UI.style.backgroundColor = 'black';
    gLayer04UI.style.borderCollapse = "collapse"

    var td1 = document.createElement('td');
    var td2 = document.createElement('td');
    td1.style.margin = '0px';
    td1.style.padding = '0px';
    td1.style.backgroundColor = 'white';
    td1.style.borderWidth = '0px';
    td1.style.width = '50px';
    //td1.style.height = '30px';

    td2.style.margin = '0px';
    td2.style.padding = '0px';
    td2.style.backgroundColor = 'white';
    td2.style.borderWidth = '0px';
    td2.style.width = '50px';
    //td2.style.height = '30px';

    gLayer04TextUI = document.createElement('div');
    gLayer04TextUI.setAttribute('style', styleXXX);
    //gLayer04TextUI.style.width = '70px';
    gLayer04TextUI.innerHTML = gText_LayerWeather;

    gLayer04CheckedUI = document.createElement('div');
    //gLayer04CheckedUI.setAttribute('style', styleXXX);
    //gLayer04CheckedUI.style.width = '30px';
    if (gWeatherDegreeIsC == true) {
        gLayer04CheckedUI.innerHTML = '<input id="weather_degree_type" onclick="layerWeatherDigreeType()" padding="0px" margin="0px" type="checkbox" checked>' + '\u00B0 C' + '</input>';
    } else {
        gLayer04CheckedUI.innerHTML = '<input id="weather_degree_type" onclick="layerWeatherDigreeType()" padding="0px" margin="0px" type="checkbox">' + '\u00B0 C' + '</input>';
    }

    td1.appendChild(gLayer04TextUI);
    td2.appendChild(gLayer04CheckedUI);
    gLayer04UI.appendChild(td1);
    gLayer04UI.appendChild(td2);

    //gLayer04UI.innerHTML = gText_LayerWeather;
    //gLayer04UI.innerHTML = '<table id="myTable" border-collapse="collapse" padding="0px" margin="0px"><tr><td>cell 1</td><td>cell 2</td></tr></table>';
    //gLayer04UI.innerHTML = '<table onclick="myFunc()" id="myTable" border-collapse="collapse" padding="0px" margin="0px"><tr><td>cell 1</td><td><input type="checkbox" id="myCheck"></td></tr></table>';
    //gLayer04UI.innerHTML = '<tr rowSpan="0" colspan="0"><td>' + gText_LayerWeather + '     ' +'</td><td text-align="right" margin-right="1em"><input type="checkbox" id="myCheck" align="right">' + '\u00B0 C' + '</input></td></tr>';
    //gLayer04UI.innerHTML = '<tr onclick="myFunc()" ><td>' + gText_LayerWeather + '</td><td><input type="checkbox">' + '\u00B0 C' + '</input></td></tr>';

    gLayer05UI.innerHTML = gText_LayerPanoramio;

    gLayerGroupUI.appendChild(gLayer00UI);
    gLayerGroupUI.appendChild(gLayer01UI);
    gLayerGroupUI.appendChild(gLayer02UI);
    gLayerGroupUI.appendChild(gLayer03UI);
    gLayerGroupUI.appendChild(gLayer04UI);
    gLayerGroupUI.appendChild(gLayer05UI);

    controlDiv.appendChild(gLayerControlUI);
    controlDiv.appendChild(gLayerGroupUI);

    gLayerGroupUI.style.visibility = 'hidden';

    google.maps.event.addDomListener(gLayerControlUI, 'click', function () {

        if (gLayerGroupUI.style['visibility'] == 'hidden') {
            gLayerGroupUI.style.visibility = 'visible';
        } else {
            gLayerGroupUI.style.visibility = 'hidden';
        }
    });

    google.maps.event.addDomListener(gLayer00UI, 'click', function () {
        gLayerControlUI.innerHTML = gText_LayerNormal + arrowDownImgTag;
        //gLayerGroupUI.style.visibility = 'hidden';
        gLayer_index = 0;
        layer_set_to_map();
        MainActivityInterface.onSettingsLayerIndex(gLayer_index);
    });
    google.maps.event.addDomListener(gLayer01UI, 'click', function () {
        gLayerControlUI.innerHTML = gText_LayerTraffic + arrowDownImgTag;
        //gLayerGroupUI.style.visibility = 'hidden';
        gLayer_index = 1;
        layer_set_to_map();
        MainActivityInterface.onSettingsLayerIndex(gLayer_index);
    });
    google.maps.event.addDomListener(gLayer02UI, 'click', function () {
        gLayerControlUI.innerHTML = gText_LayerTransit + arrowDownImgTag;
        //gLayerGroupUI.style.visibility = 'hidden';
        gLayer_index = 2;
        layer_set_to_map();
        MainActivityInterface.onSettingsLayerIndex(gLayer_index);
    });
    google.maps.event.addDomListener(gLayer03UI, 'click', function () {
        gLayerControlUI.innerHTML = gText_LayerBike + arrowDownImgTag;
        //gLayerGroupUI.style.visibility = 'hidden';
        gLayer_index = 3;
        layer_set_to_map();
        MainActivityInterface.onSettingsLayerIndex(gLayer_index);
    });
    google.maps.event.addDomListener(gLayer04TextUI, 'click', function () {
        gLayerControlUI.innerHTML = gText_LayerWeather + arrowDownImgTag;
        //gLayerGroupUI.style.visibility = 'hidden';
        gLayer_index = 4;
        layer_set_to_map();
        MainActivityInterface.onSettingsLayerIndex(gLayer_index);

        if (map.getZoom() > 11) {
            map.setZoom(11);
        }
    });
    google.maps.event.addDomListener(gLayer05UI, 'click', function () {
        gLayerControlUI.innerHTML = gText_LayerPanoramio + arrowDownImgTag;
        //gLayerGroupUI.style.visibility = 'hidden';
        gLayer_index = 5;
        layer_set_to_map();
        MainActivityInterface.onSettingsLayerIndex(gLayer_index);
    });
}

function layer_set_to_map() {

    if (gTrafficLayer != null) {
        gTrafficLayer.setMap(null);
        gTrafficLayer = null;
    }
    if (gTransitLayer != null) {
        gTransitLayer.setMap(null);
        gTransitLayer = null;
    }
    if (gBikeLayer != null) {
        gBikeLayer.setMap(null);
        gBikeLayer = null;
    }
    if (gWeatherLayer != null) {
        gWeatherLayer.setMap(null);
        gWeatherLayer = null;
    }
    if (gCloudLayer != null) {
        gCloudLayer.setMap(null);
        gCloudLayer = null;
    }
    if (gPanoramioLayer != null) {
        gPanoramioLayer.setMap(null);
        gPanoramioLayer = null;
    }

    if (gLayer_index == 0) {} else if (gLayer_index == 1) {
        gTrafficLayer = new google.maps.TrafficLayer();
        gTrafficLayer.setMap(map);
    } else if (gLayer_index == 2) {
        gTransitLayer = new google.maps.TransitLayer();
        gTransitLayer.setMap(map);
    } else if (gLayer_index == 3) {
        gBikeLayer = new google.maps.BicyclingLayer();
        gBikeLayer.setMap(map);
    } else if (gLayer_index == 4) {
        if (gWeatherDegreeIsC == false) {
            gWeatherLayer = new google.maps.weather.WeatherLayer({
                temperatureUnits: google.maps.weather.TemperatureUnit.FAHRENHEIT
            });
        } else {
            gWeatherLayer = new google.maps.weather.WeatherLayer({
                temperatureUnits: google.maps.weather.TemperatureUnit.CELSIUS
            });
        }
        gWeatherLayer.setMap(map);
        gCloudLayer = new google.maps.weather.CloudLayer();
        gCloudLayer.setMap(map);


    } else if (gLayer_index == 5) {
        gPanoramioLayer = new google.maps.panoramio.PanoramioLayer();
        gPanoramioLayer.setMap(map);
    }

}
//===================================================================		

function PlacePoiSelControl(controlDiv, map) {

    // Set CSS styles for the DIV containing the control
    // Setting padding to 5 px will offset the control
    // from the edge of the map
    controlDiv.style.padding = '0px';
    controlDiv.style.paddingBottom = '20px';

    // Set CSS for the control border
    var controlUI = document.createElement('div');
    controlUI.style.width = '180px';
    controlUI.style.height = '30px';
    //controlUI.style.display = 'inline';		  
    controlUI.style.backgroundColor = 'white';
    //controlUI.style.borderStyle = 'solid';
    //controlUI.style.borderWidth = '2px';
    controlUI.style.border = '1px solid rgba(0, 0, 0, 0.14902)';
    controlUI.style.boxShadow = '1px 2px 4px -1px rgba(0, 0, 0, 0.298039)';
    //controlUI.style.cursor = 'pointer';
    //controlUI.style.textAlign = 'center';
    //controlUI.title = 'Click to set the map to Home';
    controlDiv.appendChild(controlUI);

    var table = document.createElement('table');
    table.style.borderCollapse = "collapse"
    table.style.tableLayout = "fixed";
    for (var i = 1; i < 2; i++) {
        var tr = document.createElement('tr');
        tr.style.margin = '0px';
        tr.style.padding = '0px';
        tr.style.backgroundColor = 'black';
        tr.style.borderCollapse = "collapse"

        var td1 = document.createElement('td');
        var td2 = document.createElement('td');
        var td3 = document.createElement('td');
        td1.style.margin = '0px';
        td1.style.padding = '0px';
        td1.style.backgroundColor = 'white';
        td1.style.borderWidth = '0px';
        td1.style.width = '30px';
        td1.style.height = '30px';
        //td1.style.tableLayout="fixed";
        //td1.style.whiteSpace="nowrap";
        //td1.style.overflow="scroll";

        td2.style.margin = '0px';
        td2.style.padding = '0px';
        td2.style.backgroundColor = 'white';
        td2.style.borderWidth = '0px';
        td2.style.width = '120px';
        td2.style.height = '30px';
        //td2.style.tableLayout="fixed";
        //td2.style.whiteSpace="nowrap";
        //td2.style.overflow="scroll";

        td3.style.margin = '0px';
        td3.style.padding = '0px';
        td3.style.backgroundColor = 'white';
        td3.style.borderWidth = '0px';
        td3.style.width = '30px';
        td3.style.height = '30px';
        //td3.style.tableLayout="fixed";
        //td3.style.whiteSpace="nowrap";
        //td3.style.overflow="scroll";

        // Set CSS for the control interior
        var leftControlImg = document.createElement('div');
        leftControlImg.style.width = '30px';
        leftControlImg.innerHTML = '<img border="0" src="file:///android_asset/goo/rewind.png" alt="xxx" width="30" height="30">';

        var middleControlDiv = document.createElement('div');
        middleControlDiv.style.width = '120px';
        middleControlDiv.style.textAlign = 'center';
        gPlacePoiSel_ControlText = document.createElement('div');
        gPlacePoiSel_ControlText.style.backgroundColor = 'white';
        gPlacePoiSel_ControlText.style.marginLeft = 'auto';
        gPlacePoiSel_ControlText.style.marginRight = 'auto';
        //gPlacePoiSel_ControlText.style.width = '120px';
        gPlacePoiSel_ControlText.style.whiteSpace = "nowrap";
        //gPlacePoiSel_ControlText.style.overflow = "scroll";
        gPlacePoiSel_ControlText.style.fontFamily = 'Arial,sans-serif';
        gPlacePoiSel_ControlText.style.fontSize = '12px';
        gPlacePoiSel_ControlText.innerHTML = "";
        //gPlacePoiSel_ControlText = document.createTextNode("");			  
        middleControlDiv.appendChild(gPlacePoiSel_ControlText);

        // Set CSS for the control interior
        var rightControlImg = document.createElement('div');
        rightControlImg.style.width = '30px';
        rightControlImg.innerHTML = '<img border="0" src="file:///android_asset/goo/forward.png" alt="xxx" width="30" height="30">';

        td1.appendChild(leftControlImg);
        td2.appendChild(middleControlDiv);
        td3.appendChild(rightControlImg);

        tr.appendChild(td1);
        tr.appendChild(td2);
        tr.appendChild(td3);

        table.appendChild(tr);

        google.maps.event.addDomListener(td1, 'click', function () {
            if (gPlaceIndex <= 0) {
                place_modifyPlacePoiMarker(gPlace_markers.length - 1);
            } else {
                place_modifyPlacePoiMarker(gPlaceIndex - 1);
            }
        });

        google.maps.event.addDomListener(td2, 'click', function () {

            //console.log("gPlace_places.length = " + gPlace_places.length);

            MainActivityInterface.onPlaceNameAddrBegin();
            for (var i = 0; i < gPlace_places.length; i++) {
                MainActivityInterface.onPlaceNameAddrSet(i, gPlace_places[i].name, gPlace_places[i].formatted_address);
            }
            MainActivityInterface.onPlaceNameAddrEnd();
        });

        google.maps.event.addDomListener(td3, 'click', function () {
            if (gPlaceIndex >= gPlace_markers.length - 1) {
                place_modifyPlacePoiMarker(0);
            } else {
                place_modifyPlacePoiMarker(gPlaceIndex + 1);
            }
        });
    }
    controlUI.appendChild(table);
}

//===================================================================
function placeSetPosition(pos) {

    place_modifyPlacePoiMarker(pos);
}

function setCenterAfterScreenSwitch() {

    map.setCenter(gView_Center);
    map.panTo(gView_Center);
}

function setGotoFullScreenImage(isFullScreenImg) {

    if (isFullScreenImg == true) {
        gSwichScreen_ControlUI.innerHTML = '<img src="file:///android_asset/goo/to_full_screen_normal.png" style="border: 0px; padding: 0px; width: 32px; height: 32px;">';
    } else {
        gSwichScreen_ControlUI.innerHTML = '<img src="file:///android_asset/goo/to_normal_screen_normal.png" style="border: 0px; padding: 0px; width: 32px; height: 32px;">';
    }

    setTimeout("setCenterAfterScreenSwitch()", 100);
}

//S-EV
function setBackKeyPressed() {

    if (gIsPlaceSearchInputFocus == true) {

        gIsPlaceSearchFuncAlreadyProcess = true;

        gPlaceSearchValueTmp = gPlaceSearchValueOld;
        setTimeout("placeSearchInputBlurAndUpdateValue()", 100);
    }
}

//S-EV
function searchBlurFinalCheck() {

    if (gIsPlaceSearchFuncAlreadyProcess == true) {} else {

        gPlaceSearchValueTmp = gPlaceSearchValueOld;
        placeSearchInputBlurAndUpdateValue();
    }
}

function placeSearchInputBlurAndUpdateValue() {

    document.activeElement.blur();
    gPlaceSearchControlInput.value = gPlaceSearchValueTmp;
    MainActivityInterface.onSettingsPlaceSearchValue(gPlaceSearchValueTmp);
}

function placeSearchInputOnFocus() {
    //console.log("onfocus");

    MainActivityInterface.onPlaceSearchInputFocus(true);
    gIsPlaceSearchInputFocus = true;
    gIsPlaceSearchFuncAlreadyProcess = false;
    gPlaceSearchValueTmp = gPlaceSearchValueOld = gPlaceSearchControlInput.value;
}

function placeSearchInputOnBlur() {
    //console.log("onblur");

    gIsPlaceSearchInputFocus = false;
    //gIsPlaceSearchFuncAlreadyProcess = false;
    MainActivityInterface.onPlaceSearchInputFocus(false);

    setTimeout("searchBlurFinalCheck()", 1000);
}

function place_search() {

    var request = {
        location: gLatLng,
        radius: '5000',
        types: ['store']
    };

    var service = new google.maps.places.PlacesService(map);
    service.nearbySearch(request, place_callback);

}

function place_textSearch() {
    var request = {
        location: gLatLng,
        radius: '5000',
        //query: '北京'
        //query: 'restaurant'
        query: gPlaceSearchControlInput.value
    };

    var service = new google.maps.places.PlacesService(map);
    service.textSearch(request, place_callback);
}

function place_callback(results, status) {

    //if(gPlaceSearchValueOld!=gPlaceSearchValueTmp){
    //	gPlaceIndex = 0;
    //}

    //console.log(status);
    if (status == google.maps.places.PlacesServiceStatus.OK) {
        for (var i = 0; i < results.length; i++) {
            place_createMarker(i, results[i]);
        }

        //console.log("results.length=" + results.length);

        if (gPlaceCmpIndex < results.length) {
            if (gPlaceCmpString == gPlace_places[gPlaceCmpIndex].name) {} else {
                gPlaceIndex = 0;
            }
        } else {
            gPlaceIndex = 0;
        }

        if (results.length >= 1) {

            if (gIsPlaceDivPushed == false) {
                // http://stackoverflow.com/questions/8414587/google-maps-javascript-api-v3-how-to-remove-custom-control
                map.controls[google.maps.ControlPosition.BOTTOM_CENTER].push(gPlacePoiSelControlDiv);
                gIsPlaceDivPushed = true;
            }
            //gPlacePoiSelControlDiv.style.visibility = 'visible';

            if (results.length > gPlaceIndex) {
                place_modifyPlacePoiMarker(gPlaceIndex);
            } else {
                place_modifyPlacePoiMarker(0);
            }
        } else {
            // should not come here
            placeSearchPlacesClose();

            MainActivityInterface.onToastPlaceSearchStatusERROR(gPlaceSearchControlInput.value, status);
        }
    } else {
        placeSearchPlacesClose();

        MainActivityInterface.onToastPlaceSearchStatusERROR(gPlaceSearchControlInput.value, status);
    }
}

function place_processSVDataCallback(data, status) {

    var content = "";
    if (gPlace_detail.name != null && gPlace_detail.name != undefined) {
        content += gPlace_detail.name + "<BR>";
    }
    if (gPlace_detail.formatted_address != null && gPlace_detail.formatted_address != undefined) {
        content += gPlace_detail.formatted_address + "<BR>";
    }
    if (gPlace_detail.website != null && gPlace_detail.website != undefined) {
        content += '<a href="' + gPlace_detail.website + '">' + gPlace_detail.website + '</a>' + "<BR>";
        // <a href="http://www.w3schools.com/">W3Schools</a>
    }
    if (gPlace_detail.formatted_phone_number != null && gPlace_detail.formatted_phone_number != undefined) {

        var number = gPlace_detail.formatted_phone_number; // a string
        number = number.replace(/[^0-9]/g, ''); // a string of only digits, or the empty string
        //number = parseInt(number, 10); // now it's a numeric value

        content += '<a href="tel:' + number + '">' + gPlace_detail.formatted_phone_number + '</a>' + "<BR>";
        // <a href="tel:+1800229933">Call us free!</a>
    }

    content += "<BR>";

    if (status == google.maps.StreetViewStatus.OK) {

        content += '<button id="mySvBtn" type="button" onclick="place_streetView_gotoSV()">' + gText_BtnStreetView + '</button>';
        //content += '<button type="button">' + 'Try tttt' + '</button>';
        // <button type="button" onclick="myFunction()">Try it</button>
        content += "<BR>";
    }

    /*
		var content = gPlace_detail.name + "<BR>" + 
						gPlace_detail.formatted_address + "<BR>" + 
						gPlace_detail.formatted_phone_number + "<BR>" +
						gPlace_detail.international_phone_number + "<BR>" +
						gPlace_detail.opening_hours + "<BR>" +
						gPlace_detail.rating + "<BR>" +
						gPlace_detail.reviews + "<BR>" +
						gPlace_detail.url + "<BR>" +
						gPlace_detail.website;
		*/

    gPlaceInfowindow.setContent(content);
    gPlaceInfowindow.open(map, gPlace_markers[gPlaceIndex]);

    //var myButton = gPlaceInfowindow.getElementById('mySvBtn');
    //google.maps.event.addDomListener(myButton, 'place_streetView_gotoSV', gPlaceInfowindow);	
}

function place_detailCallback(place, status) {

    if (status == google.maps.places.PlacesServiceStatus.OK) {

        gPlace_detail = place;

        if (gSV_serviceInited == false) {
            gSV_service = new google.maps.StreetViewService();
            gSV_serviceInited = true;
        }
        gSV_service.getPanoramaByLocation(place.geometry.location, 50, place_processSVDataCallback);
    }
}


function place_modifyPlacePoiMarker(index) {

    gPlaceIndex = index;

    /*
			if(gMarkerPlacePoi!=null){	
				clearTimeout(gTimeoutId_1);
				gMarkerPlacePoi.setMap(null);
				gMarkerPlacePoi = null;
			}
			
			gMarkerPlacePoi = new google.maps.Marker({
			  position: gPlace_places[index].geometry.location,
			  //map: map,
			  animation: google.maps.Animation.DROP,
			  icon: 'file:///android_asset/goo/blue-dot.png'
			});
			gMarkerPlacePoi.setMap(map);
			gMarkerPlacePoi.setAnimation(google.maps.Animation.BOUNCE);	
			
			gTimeoutId_1 = setTimeout("timeoutFunc_1()", 2000);
			*/

    map.setCenter(gPlace_places[index].geometry.location);
    map.panTo(gPlace_places[index].geometry.location);

    place_updateInfoWindow();

    gPlaceCmpIndex = index;
    gPlaceCmpString = gPlace_places[index].name;
    MainActivityInterface.onSettingsPlaceCmpIndex(gPlaceCmpIndex);
    MainActivityInterface.onSettingsPlaceCmpString(gPlaceCmpString);

    place_setStrokeColor(index);
}

function place_streetView_gotoSV() {

    gSV_panorama = map.getStreetView();
    gSV_panorama.setPosition(gPlace_places[gPlaceIndex].geometry.location);
    gSV_panorama.setPov( /** @type {google.maps.StreetViewPov} */ ({
        heading: 265,
        pitch: 0
    }));
    gSV_panorama.setVisible(true);
}

function place_updateInfoWindow() {

    //gPlaceInfowindow.setContent(gPlace_places[gPlaceIndex].name + "<BR>" + gPlace_places[gPlaceIndex].formatted_address);
    //gPlaceInfowindow.open(map, gPlace_markers[gPlaceIndex]);

    var request = {
        reference: gPlace_places[gPlaceIndex].reference
    };

    var service = new google.maps.places.PlacesService(map);
    service.getDetails(request, place_detailCallback);

    gPlacePoiSel_ControlText.innerHTML = gPlace_places[gPlaceIndex].name;
    //gPlacePoiSel_ControlText.innerText = gPlace_places[gPlaceIndex].name;		
}

function place_createMarker(index, place) {

    var marker = new google.maps.Marker({
        map: map,
        position: place.geometry.location,
        //icon: 'file:///android_asset/goo/blue-dot.png'
        //icon: place.icon
        icon: {
            path: google.maps.SymbolPath.FORWARD_CLOSED_ARROW,
            strokeColor: "#990099",
            scale: 2
        },
    });

    //console.log("BP places.length=" + gPlace_places.length);
    //console.log("BP markers.length=" + gPlace_markers.length);

    gPlace_places.push(place);
    gPlace_markers.push(marker);

    //console.log("EP places.length=" + gPlace_places.length);
    //console.log("EP markers.length=" + gPlace_markers.length);

    google.maps.event.addListener(marker, 'click', function () {

        gPlaceIndex = index;

        place_updateInfoWindow();

    });

    /*
    console.log(">>>");
    console.log("place.geometry.location = " + place.geometry.location);
    console.log("place.geometry.viewport = " + place.geometry.viewport);
    console.log("place.icon = " + place.icon);
    console.log("place.id = " + place.id);
    console.log("place.name = " + place.name);
    console.log("place.opening_hours = " + place.opening_hours);
    console.log("place.rating = " + place.rating);
    console.log("place.reference = " + place.reference);
    console.log("place.types = " + place.types);
    console.log("place.vicinity = " + place.vicinity);
    console.log("place.formatted_address = " + place.formatted_address);
    console.log("<<<");
	*/
}

function place_setStrokeColor(index) {
    for (var i = 0; i < gPlace_markers.length; i++) {

        if (i == index) {
            gPlace_markers[i].setIcon({
                path: google.maps.SymbolPath.FORWARD_CLOSED_ARROW,
                strokeColor: "#FF00FF",
                scale: 2
            });
        } else {
            gPlace_markers[i].setIcon({
                path: google.maps.SymbolPath.FORWARD_CLOSED_ARROW,
                strokeColor: "#990099",
                scale: 2
            });
        }
    }
}

function place_setAllMap(map) {
    for (var i = 0; i < gPlace_markers.length; i++) {
        gPlace_markers[i].setMap(map);
    }
}

function place_clearMarkers() {
    place_setAllMap(null);
}

function place_showMarkers() {
    place_setAllMap(map);
}

function place_deleteMarkers() {

    //console.log("place_deleteMarkers");

    place_clearMarkers();
    gPlace_places = [];
    gPlace_markers = [];
}
//===================================================================	