// Javascript Indent Tool : http://jsbeautifier.org/

function consoleLog(logStr){
	MainActivityInterface.onLogString(logStr);
}

function modifyMarker(lat, lng) {

	consoleLog("modifyMarker.");
		
	//if(gMarkerCur!=null){}	
		// reference: http://stackoverflow.com/questions/9212776/nokia-ovi-maps-issue-dynamic-refresh-of-markers	
	//	map.objects.remove(gMarkerCur);	
	//}
	
	map.objects.clear();
	
	//var coord = new nokia.maps.geo.Coordinate(lat, lng);	
	//gMarkerCur = new nokia.maps.map.StandardMarker(coord);
	
	gMarkerCur = new nokia.maps.map.Marker(
		// Geo coordinate of the marker.
		new nokia.maps.geo.Coordinate(lat, lng), {
	
			// Make the marker draggable.
			draggable: false,
			
			// Set the icon of the marker.
			icon: "file:///android_asset/nok/gps_icon_32x47.png",
			
			// Set the anchor point of the marker's icon
			anchor: new nokia.maps.util.Point(35, 89)
	});	
	
	
	// Next we need to add it to the map's object collection so it will be rendered onto the map.
	map.objects.add(gMarkerCur);
	
	map.set("center", coord);
	
}

function initOtherSettings() {


}

function addChangeListener() {

	consoleLog("addChangeListener.");

	var mapContainer = document.getElementById("mapContainer");

    var switchScreenControlDiv = document.createElement('div');
    var switchScreenControl = new SwitchScreenControl(switchScreenControlDiv, null);
	
	switchScreenControlDiv.className = "div_left_bottom";
	mapContainer.appendChild(switchScreenControlDiv);
}

function SwitchScreenControl(controlDiv, map) {

    // Set CSS styles for the DIV containing the control
    // Setting padding to 5 px will offset the control
    // from the edge of the map
    controlDiv.style.paddingLeft = '5px';
    controlDiv.style.paddingBottom = '50px';

    // Set CSS for the control border
    var controlUI = document.createElement('div');
    controlUI.style.backgroundColor = 'white';
    controlUI.style.border = '1px solid rgba(0, 0, 0, 0.14902)';
    controlUI.style.cursor = 'pointer';
    controlUI.style.textAlign = 'center';
    controlUI.title = '';
    controlDiv.appendChild(controlUI);

    // Set CSS for the control interior
    gSwichScreen_ControlUI = document.createElement('div');
    gSwichScreen_ControlUI.style.width = '32px';
    gSwichScreen_ControlUI.style.height = '32px';
    gSwichScreen_ControlUI.innerHTML = '<img src="file:///android_asset/goo/to_full_screen_normal.png" onclick="click_switchScreen()" style="border: 0px; padding: 0px; width: 32px; height: 32px;">';
    controlUI.appendChild(gSwichScreen_ControlUI);

/*
    //google.maps.event.addDomListener(controlUI, 'click', function () {
    gSwichScreen_ControlUI.onclick = function() {

        consoleLog("onMapScreenChanged");

        //gView_Center = map.getCenter();
        //MainActivityInterface.onMapScreenChanged();
    });
*/
}

function click_switchScreen(){

	consoleLog("onMapScreenChanged");
    
    //gView_Center = map.getCenter();
    MainActivityInterface.onMapScreenChanged();
        
}

function setCenterAfterScreenSwitch() {

    //map.setCenter(gView_Center);
    //map.panTo(gView_Center);
}

function setGotoFullScreenImage(isFullScreenImg) {

    if (isFullScreenImg == true) {
        gSwichScreen_ControlUI.innerHTML = '<img src="file:///android_asset/goo/to_full_screen_normal.png" onclick="click_switchScreen()" style="border: 0px; padding: 0px; width: 32px; height: 32px;">';
    } else {
        gSwichScreen_ControlUI.innerHTML = '<img src="file:///android_asset/goo/to_normal_screen_normal.png" onclick="click_switchScreen()" style="border: 0px; padding: 0px; width: 32px; height: 32px;">';
    }

    setTimeout("setCenterAfterScreenSwitch()", 100);
}

